Open Lighting Architecture: ola::AbstractPlugin Class Reference

| Open Lighting Architecture 0.10.9

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ola::AbstractPlugin Class Referenceabstract

## Detailed Description

The interface for a plugin

Inheritance diagram for ola::AbstractPlugin:

## Public Member Functions
virtual bool | LoadPreferences ()=0
| Load the preferences for a plugin and set defaults.
virtual std::string | PreferenceConfigLocation () const =0
| The location for preferences.
virtual bool | IsEnabled () const =0
| Is the plugin enabled?
virtual void | SetEnabledState (bool enable)=0
| Set the plugin's enabled state.
virtual bool | Start ()=0
| Start the plugin.
virtual bool | Stop ()=0
| Stop the plugin.
virtual ola_plugin_id | Id () const =0
| Get the plugin ID of this plugin.
virtual std::string | Name () const =0
| Get the plugin name.
virtual std::string | Description () const =0
virtual void | ConflictsWith (std::set< ola_plugin_id > *conflict_set) const =0
virtual bool | operator< (const AbstractPlugin &other) const =0

## Member Function Documentation

## ◆ Description()

virtual std::string ola::AbstractPlugin::Description | ( |  | ) | const
| pure virtual

Return the description for this plugin.

Returns
  a string description of the plugin

Implemented in ola::plugin::artnet::ArtNetPlugin, ola::plugin::dmx4linux::Dmx4LinuxPlugin, ola::plugin::dummy::DummyPlugin, ola::plugin::e131::E131Plugin, ola::plugin::espnet::EspNetPlugin, ola::plugin::ftdidmx::FtdiDmxPlugin, ola::plugin::gpio::GPIOPlugin, ola::plugin::karate::KaratePlugin, ola::plugin::kinet::KiNetPlugin, ola::plugin::milinst::MilInstPlugin, ola::plugin::opendmx::OpenDmxPlugin, ola::plugin::openpixelcontrol::OPCPlugin, ola::plugin::osc::OSCPlugin, ola::plugin::pathport::PathportPlugin, ola::plugin::renard::RenardPlugin, ola::plugin::sandnet::SandNetPlugin, ola::plugin::shownet::ShowNetPlugin, ola::plugin::spi::SPIPlugin, ola::plugin::stageprofi::StageProfiPlugin, ola::plugin::uartdmx::UartDmxPlugin, ola::plugin::usbdmx::UsbDmxPlugin, and ola::plugin::usbpro::UsbSerialPlugin.

## ◆ Id()

virtual ola_plugin_id ola::AbstractPlugin::Id | ( |  | ) | const
| pure virtual

Get the plugin ID of this plugin.

Returns
  the ola_plugin_id of this plugin

Implemented in ola::plugin::artnet::ArtNetPlugin, ola::plugin::dmx4linux::Dmx4LinuxPlugin, ola::plugin::dummy::DummyPlugin, ola::plugin::e131::E131Plugin, ola::plugin::espnet::EspNetPlugin, ola::plugin::ftdidmx::FtdiDmxPlugin, ola::plugin::gpio::GPIOPlugin, ola::Plugin, ola::plugin::karate::KaratePlugin, ola::plugin::kinet::KiNetPlugin, ola::plugin::milinst::MilInstPlugin, ola::plugin::opendmx::OpenDmxPlugin, ola::plugin::openpixelcontrol::OPCPlugin, ola::plugin::osc::OSCPlugin, ola::plugin::pathport::PathportPlugin, ola::plugin::renard::RenardPlugin, ola::plugin::sandnet::SandNetPlugin, ola::plugin::shownet::ShowNetPlugin, ola::plugin::spi::SPIPlugin, ola::plugin::stageprofi::StageProfiPlugin, ola::plugin::uartdmx::UartDmxPlugin, ola::plugin::usbdmx::UsbDmxPlugin, and ola::plugin::usbpro::UsbSerialPlugin.

## ◆ IsEnabled()

virtual bool ola::AbstractPlugin::IsEnabled | ( |  | ) | const
| pure virtual

Is the plugin enabled?

Returns
  true if this plugin is enabled

Implemented in ola::Plugin.

## ◆ LoadPreferences()

virtual bool ola::AbstractPlugin::LoadPreferences | ( |  | ) |
| pure virtual

Load the preferences for a plugin and set defaults.

Implemented in ola::Plugin.

## ◆ Name()

virtual std::string ola::AbstractPlugin::Name | ( |  | ) | const
| pure virtual

Get the plugin name.

Returns
  the name of this plugin

Implemented in ola::plugin::artnet::ArtNetPlugin, ola::plugin::dmx4linux::Dmx4LinuxPlugin, ola::plugin::dummy::DummyPlugin, ola::plugin::e131::E131Plugin, ola::plugin::espnet::EspNetPlugin, ola::plugin::ftdidmx::FtdiDmxPlugin, ola::plugin::gpio::GPIOPlugin, ola::plugin::karate::KaratePlugin, ola::plugin::kinet::KiNetPlugin, ola::plugin::milinst::MilInstPlugin, ola::plugin::opendmx::OpenDmxPlugin, ola::plugin::openpixelcontrol::OPCPlugin, ola::plugin::osc::OSCPlugin, ola::plugin::pathport::PathportPlugin, ola::plugin::renard::RenardPlugin, ola::plugin::sandnet::SandNetPlugin, ola::plugin::shownet::ShowNetPlugin, ola::plugin::spi::SPIPlugin, ola::plugin::stageprofi::StageProfiPlugin, ola::plugin::uartdmx::UartDmxPlugin, ola::plugin::usbdmx::UsbDmxPlugin, and ola::plugin::usbpro::UsbSerialPlugin.

## ◆ PreferenceConfigLocation()

virtual std::string ola::AbstractPlugin::PreferenceConfigLocation | ( |  | ) | const
| pure virtual

The location for preferences.

This can be anything really but should indicate to the user how the preferences were loaded.

Implemented in ola::Plugin.

## ◆ SetEnabledState()

virtual void ola::AbstractPlugin::SetEnabledState | ( | bool | enable | ) |
| pure virtual

Set the plugin's enabled state.

Parameters

  enable | The new enabled state

Returns
  true if this plugin is enabled

Implemented in ola::Plugin.

## ◆ Start()

virtual bool ola::AbstractPlugin::Start | ( |  | ) |
| pure virtual

Start the plugin.

Calls StartHook() which can be overridden by the derived classes.

Returns
  true if we started ok, false otherwise

Implemented in ola::Plugin.

## ◆ Stop()

virtual bool ola::AbstractPlugin::Stop | ( |  | ) |
| pure virtual

Stop the plugin.

Calls StopHook() which can be overridden by the derived classes.

Returns
  true on success, false on failure

Implemented in ola::Plugin.

The documentation for this class was generated from the following file:

- include/olad/Plugin.h